local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('linux_errno')

ffi.cdef[[
int *__errno_location(void);
]]

local defs = {
    ECANCELED = '125',
    EOWNERDEAD = '130',
    ENOTRECOVERABLE = '131',
    ERFKILL = '132',
    EHWPOISON = '133',
    EDOM = '33',
    EILSEQ = '84',
    ERANGE = '34',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

