local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_resource')

ffi.cdef[[
typedef __id_t id_t;
typedef enum __rlimit_resource __rlimit_resource_t;
typedef enum __rusage_who __rusage_who_t;
typedef enum __priority_which __priority_which_t;
int getrlimit(__rlimit_resource_t __resource, struct rlimit *__rlimits);
int getrlimit64(__rlimit_resource_t __resource,
    struct rlimit64 *__rlimits);
int setrlimit(__rlimit_resource_t __resource,
    const struct rlimit *__rlimits);
int setrlimit64(__rlimit_resource_t __resource,
    const struct rlimit64 *__rlimits);
int getrusage(__rusage_who_t __who, struct rusage *__usage);
int getpriority(__priority_which_t __which, id_t __who);
int setpriority(__priority_which_t __which, id_t __who, int __prio);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

