local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types')
lj_include('time')

ffi.cdef[[
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __ino_t ino_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __off_t off_t;
typedef __uid_t uid_t;
typedef __blkcnt_t blkcnt_t;
typedef __blksize_t blksize_t;
]]

lj_include('bits_stat')

ffi.cdef[[
int stat(const char *__file, struct stat *__buf);
int fstat(int __fd, struct stat *__buf);
int stat64(const char *__file, struct stat64 *__buf);
int fstat64(int __fd, struct stat64 *__buf);
int fstatat(int __fd, const char *__file, struct stat *__buf, int __flag);
int fstatat64(int __fd, const char *__file,
    struct stat64 *__buf, int __flag);
int lstat(const char *__file, struct stat *__buf);
int lstat64(const char *__file, struct stat64 *__buf);
int chmod(const char *__file, __mode_t __mode);
int lchmod(const char *__file, __mode_t __mode);
int fchmod(int __fd, __mode_t __mode);
int fchmodat(int __fd, const char *__file, __mode_t __mode, int __flag);
__mode_t umask(__mode_t __mask);
__mode_t getumask(void);
int mkdir(const char *__path, __mode_t __mode);
int mkdirat(int __fd, const char *__path, __mode_t __mode);
int mknod(const char *__path, __mode_t __mode, __dev_t __dev);
int mknodat(int __fd, const char *__path, __mode_t __mode, __dev_t __dev);
int mkfifo(const char *__path, __mode_t __mode);
int mkfifoat(int __fd, const char *__path, __mode_t __mode);
int utimensat(int __fd, const char *__path,
    const struct timespec __times[2], int __flags);
int futimens(int __fd, const struct timespec __times[2]);
int __fxstat(int __ver, int __fildes, struct stat *__stat_buf);
int __xstat(int __ver, const char *__filename, struct stat *__stat_buf);
int __lxstat(int __ver, const char *__filename, struct stat *__stat_buf);
int __fxstatat(int __ver, int __fildes, const char *__filename,
    struct stat *__stat_buf, int __flag);
int __fxstat64(int __ver, int __fildes, struct stat64 *__stat_buf);
int __xstat64(int __ver, const char *__filename,
    struct stat64 *__stat_buf);
int __lxstat64(int __ver, const char *__filename,
    struct stat64 *__stat_buf);
int __fxstatat64(int __ver, int __fildes, const char *__filename,
    struct stat64 *__stat_buf, int __flag);
int __xmknod(int __ver, const char *__path, __mode_t __mode,
    __dev_t * __dev);
int __xmknodat(int __ver, int __fd, const char *__path,
    __mode_t __mode, __dev_t * __dev);
]]

local defs = {
    S_BLKSIZE = '512',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

